#ifndef __SPRITE_H__
#define __SPRITE_H__

#include <sps2lib.h>
#include <sps2tags.h>
#include <sps2regstructs.h>
#include <assert.h>
#include "PS2Defines.h"
#include "AddRegisters.h"


class CSprite
{
public:
	CSprite( int xTexture, int yTexture, int widthTexture, int heightTexture);
	~CSprite();

	void CSprite::setPos(int xPos, int yPos);
	void CSprite::setAngle(float Angle);
	void CSprite::addAngle(float Angle);
	void CSprite::setPosAll(int xPos1, int yPos1, int xPos2, int yPos2, int xPos3, int yPos3, int xPos4, int yPos4);
	void CSprite::setTexturePos(float s1, float s2, float t1, float t2);
	void CSprite::movePos(int xPos, int yPos);
	void CSprite::setVisible(bool isVisible);

	bool CSprite::getVisible(void);
	int CSprite::getXPos(void);
	int CSprite::getYPos(void);
	int CSprite::getXPos1(void);
	int CSprite::getYPos1(void);
	int CSprite::getXPos2(void);
	int CSprite::getYPos2(void);
	int CSprite::getXPos3(void);
	int CSprite::getYPos3(void);
	int CSprite::getXPos4(void);
	int CSprite::getYPos4(void);
//	bool CSprite::inside(CSprite inSprite);

	void CSprite::addSpriteToMem(char *& pMem, int Zvalue);
	void CSprite::addSpriteToGIFTag(char *& pMem, int Zvalue);
	void CSprite::AddGIFTag(char *& pMem, int numSprites);


private:
	int m_width, m_height;
	int m_xPos, m_yPos;
	int m_xPos1, m_yPos1;
	int m_xPos2, m_yPos2;
	int m_xPos3, m_yPos3;
	int m_xPos4, m_yPos4;
	int m_Red, m_Green, m_Blue;
	bool m_isVisible;
	float m_s1, m_s2, m_t1, m_t2;
	float m_Angle;
	float fHalfW, fHalfH;


};

#endif